#
# Spec file for ocfs-tools
#

# Macros
# This one is hardcoded because, well, it belongs there
%define _prefix /usr
# Because RPM is dumb
%define _unpackaged_files_terminate_build 0
# Because RH defines lib64 on ppc32 builds
%ifarch ppc
%define brokenrhlibdir /usr/lib
%else
%define brokenrhlibdir %{_libdir}
%endif


%define build_ocfs2console	0
%define compile_py		0

%if %{build_ocfs2console}
%define compile_py		1
%endif

Summary: Tools for managing the Oracle Cluster Filesystem 2
Name: ocfs2-tools
Version: 1.8.0
Release: 10.el6
License: GPL
Group: System Environment/Kernel
Source: ocfs2-tools-1.8.0.tar.gz
URL: http://oss.oracle.com/projects/ocfs2-tools/
Distribution: Oracle
Vendor: Oracle
Packager: nobody <nobody@oracle.com>
Exclusiveos: Linux
Requires: bash, which, coreutils, net-tools, modutils, e2fsprogs, chkconfig, glib2 >= 2.2.3, util-linux >= 2.12j, redhat-lsb
BuildRequires: e2fsprogs-devel, glib2-devel >= 2.2.3, pygtk2 >= 1.99.16, python-devel >= 2.4, util-linux >= 2.12j

BuildRoot: %{_tmppath}/ocfs2-tools-%{PACKAGE_VERSION}-%{PACKAGE_RELEASE}-root
%if !%{build_ocfs2console}
Obsoletes: ocfs2console
%endif

Patch1: dummy.patch
Patch2: 20110610.patch
Patch3: 20110610-fix.patch
Patch4: 20110623.patch
Patch5: 20110624.patch
Patch6: addfiemap.patch
Patch7: 20110804.patch
Patch8: 20110804a.patch
# End Oracle Patches

%description
Tools to manage Oracle Cluster Filesystem 2 volumes.


%if %{build_ocfs2console}
%package -n ocfs2console
Summary: GUI frontend for OCFS2 management
Group: System Environment/Kernel
Requires: e2fsprogs, glib2 >= 2.2.3, vte >= 0.11.10, pygtk2 >= 1.99.16, python >= 2.4, ocfs2-tools = %{version}
AutoReqProv: No


%description -n ocfs2console
GUI frontend for management and debugging of Oracle Cluster Filesystem 2
volumes.
%endif


%package -n ocfs2-tools-devel
Summary: Headers and static archives for ocfs2-tools
Group: Development/Libraries
Requires: e2fsprogs-devel, glib2-devel >= 2.2.3, ocfs2-tools = %{version}
AutoReqProv: No

%description -n ocfs2-tools-devel
ocfs2-tools-devel contains the libraries and header files needed to
develop ocfs2 filesystem-specific programs.



%prep
%setup -n ocfs2-tools-%{version}
%patch1 -p0
%patch2 -p0
%patch3 -p0
%patch4 -p0
%patch5 -p0
%patch6 -p0
%patch7 -p0
%patch8 -p0


%build
%configure --disable-debug --enable-dynamic-ctl --prefix=/usr --mandir=/usr/share/man --libdir=%{brokenrhlibdir}
make


%install

mkdir -p $RPM_BUILD_ROOT/etc/init.d
cp -f vendor/common/o2cb.init $RPM_BUILD_ROOT/etc/init.d/o2cb
cp -f vendor/common/ocfs2.init $RPM_BUILD_ROOT/etc/init.d/ocfs2
if [ -f /etc/redhat-release ]
then
    # Red Hat chkconfig is completely and utterly broken
    perl -p -i -e 'BEGIN() { $k=0;}  if (/^###/) { $k++ } elsif ($k == 1) { printf "#"};' $RPM_BUILD_ROOT/etc/init.d/o2cb
    perl -p -i -e 'BEGIN() { $k=0;}  if (/^###/) { $k++ } elsif ($k == 1) { printf "#"};' $RPM_BUILD_ROOT/etc/init.d/ocfs2
fi
mkdir -p $RPM_BUILD_ROOT/etc/sysconfig
cp -f vendor/common/o2cb.sysconfig $RPM_BUILD_ROOT/etc/sysconfig/o2cb

make DESTDIR="$RPM_BUILD_ROOT" install

%if %{compile_py}
%{__python} -c "import compileall; compileall.compile_dir('$RPM_BUILD_ROOT/%{brokenrhlibdir}/python2.4/site-packages/ocfs2interface', ddir='%{brokenrhlibdir}/python2.4/site-packages/ocfs2interface')"
%endif


%clean
rm -rf "$RPM_BUILD_ROOT"


%post
/sbin/chkconfig --add o2cb >/dev/null
/sbin/chkconfig --add ocfs2 >/dev/null

%preun
if [ $1 = 0 ]; then     # execute this only if we are NOT doing an upgrade
	/sbin/chkconfig --del ocfs2 >/dev/null
	/sbin/chkconfig --del o2cb >/dev/null
fi

%files
%defattr(-,root,root)
%doc README.O2CB COPYING CREDITS MAINTAINERS
%doc documentation/users_guide.txt
/sbin/fsck.ocfs2
/sbin/mkfs.ocfs2
/sbin/mounted.ocfs2
/sbin/tunefs.ocfs2
/sbin/debugfs.ocfs2
/sbin/o2cb_ctl
/sbin/o2cb
/sbin/mount.ocfs2
/sbin/o2image
/sbin/ocfs2_hb_ctl
/usr/bin/o2info
/usr/sbin/o2hbmonitor
/etc/init.d/o2cb
/etc/init.d/ocfs2
%config(noreplace) /etc/sysconfig/o2cb
/usr/share/man/man8/debugfs.ocfs2.8.gz
/usr/share/man/man8/fsck.ocfs2.8.gz
/usr/share/man/man8/fsck.ocfs2.checks.8.gz
/usr/share/man/man8/mkfs.ocfs2.8.gz
/usr/share/man/man8/tunefs.ocfs2.8.gz
/usr/share/man/man8/mount.ocfs2.8.gz
/usr/share/man/man8/mounted.ocfs2.8.gz
/usr/share/man/man8/o2cb_ctl.8.gz
/usr/share/man/man8/o2cb.8.gz
/usr/share/man/man8/ocfs2_hb_ctl.8.gz
/usr/share/man/man8/o2image.8.gz
/usr/share/man/man7/o2cb.7.gz
/usr/share/man/man1/o2info.1.gz


%if %{build_ocfs2console}
%files -n ocfs2console
%defattr(-,root,root)
%{brokenrhlibdir}/python2.4/site-packages/ocfs2interface
/usr/sbin/ocfs2console
/usr/share/man/man8/ocfs2console.8.gz
%endif

%files -n ocfs2-tools-devel
%defattr(-,root,root)
%{brokenrhlibdir}/*.a
%{brokenrhlibdir}/pkgconfig/*.pc
%{_includedir}/ocfs2-kernel
%{_includedir}/o2cb
%{_includedir}/o2dlm
%{_includedir}/ocfs2



%changelog
* Fri Dec 30 2011 Keshav Sharma <keshav.sharma@oracle.com> - 1.8.0-10 
- Obsolete ocfs2console if not built.

* Thu Aug 04 2011 Sunil Mushran <sunil.mushran@oracle.com> - 1.8.0-9 
- logger added to o2cb.init 

* Thu Aug 04 2011 Sunil Mushran <sunil.mushran@oracle.com> - 1.8.0-8 
- tools updated
  ocfs2tool: Fix command stop-heartbeat and unregister-cluster
  debugfs.ocfs2: Add command grpextents
  debugfs: Add command net_stats
  debugfs: Fix open_debugfs_file()
  libocfs2: Update some error messages
  debugfs.ocfs2: Fix output of dxroot
  libocfs2: Added generic block swap functions
  libocfs2: Move metadata block type detect to libocfs2
  extras: Add utility resize_slotmap.c
  debugfs.ocfs2: Condense the print format for the various times
  debugfs.ocfs2: Add command stat_sysdir
  debugfs.ocfs2: Cleanup 

* Fri Jun 24 2011 Sunil Mushran <sunil.mushran@oracle.com> - 1.8.0-7 
- Add fiemap.h 

* Fri Jun 24 2011 Sunil Mushran <sunil.mushran@oracle.com> - 1.8.0-6 
- Makefile fix
  ff59898 tools: Add missing header to Makefile 

* Thu Jun 23 2011 Sunil Mushran <sunil.mushran@oracle.com> - 1.8.0-5 
- Tools fixes
  eb5a72c o2cb.init: Start/stop o2hbmonitor
  65ecee7 debugfs.ocfs2: fs_locks command understands version 3 locking_state format
  757826d tunefs.ocfs2: Fix segfault when disabling sparse feature
  dd2823c O2info: Add new running codes for '--filestat'.
  039b4ab O2info: Add new running codes for '--space-usage'.
  995713a O2info: Add new running codes for '--freefrag'
  4e0c215 O2info: O2info: Add new running codes for '--freeinode'
  dd6f2ca O2info: Make parts of o2info routines public.
  69759a2 ocfs2-tools: support strictatime in ocfs2
  8ed8974 ocfs2-tools: fix wrong pointer to pointer in mount.ocfs2 

* Fri Jun 10 2011 Sunil Mushran <sunil.mushran@oracle.com> - 1.8.0-4 
- Fix prev patch
  Previous patch muddled o2cb.init.sh. Fix it. 

* Fri Jun 10 2011 Sunil Mushran <sunil.mushran@oracle.com> - 1.8.0-3 
- Tools fixes
  o2cbtool: Silence usage in list-clusters
  mount.ocfs2: Fix bugs related to hard-ro mounts
  mounted.ocfs2: Quick detect mode made more efficient
  o2cbtool: Disable signals when starting heartbeat
  o2cb: Add verbose tracing to o2cb register cluster
  o2cb: Handle failure to register heartbeat mode
  tools: Cleaned up .gitignore(s)
  tools: Fix rpm building without ocfs2console
  o2cb: Add op cluster-status 

* Fri Mar 18 2011 Sunil Mushran <sunil.mushran@oracle.com> - 1.8.0-2
- o2cb init supports online-status 

* Fri Mar 18 2011 Sunil Mushran <sunil.mushran@oracle.com> - 1.8.0-1 
- Sync with ocfs2-tools git repo
  commit 2480a215a600050d2bf923044dffac91439d982a 

* Tue Mar 15 2011 Sunil Mushran <sunil.mushran@oracle.com> - 1.6.3-104 
- o2cb: Allow loop devices to be discovered in scandisk 

* Fri Nov 19 2010 Sunil Mushran <sunil.mushran@oracle.com> - 1.6.3-103 
- o2cb.init: Cleanup userdlm domains during o2cb offline
  The o2cb init service now cleans up userdlm domains during offline. It also
  creates /var/lock/susbsys/o2cb to ensure the service is stopped during shutdown. 

* Thu Oct 28 2010 Sunil Mushran <sunil.mushran@oracle.com> - 1.6.3-102 
- init scripts shutdown order tweaked 

* Wed Oct 13 2010 Sunil Mushran <sunil.mushran@oracle.com> - 1.6.3-101 
- new files that were left from the last commit 

* Wed Oct 13 2010 Sunil Mushran <sunil.mushran@oracle.com> - 1.6.3-100
- global heartbeat patches
  http://oss.oracle.com/git/?p=ocfs2-tools.git;a=shortlog;h=newo2cb 

* Wed Oct 13 2010 Sunil Mushran <sunil.mushran@oracle.com> - 1.6.3-1 
- Update tarball to version 1.6.3

* Thu Jan 27 2005 Manish Singh <manish.singh@oracle.com>
- Add ocfs2console

* Fri Jan 21 2005 Manish Singh <manish.singh@oracle.com>
- Initial rpm spec
